package PST2;
/* PST2.UpravaFakulteta.java
 * @autor  prof. dr Sinisa Vlajic,
 * Univerzitet u Beogradu
 * Fakultet organizacionih nauka 
 * Katedra za softversko inzenjerstvo
 * Laboratorija za softversko inzenjerstvo
 * 05.12.2017
 */

//   PST2:              .
//    ,    : "".        : "".
//    ,      .
// ,        .

abstract class Stanje
{abstract Stanje obradi();}

class Obradjena extends Stanje
{ @Override
  Stanje obradi() {System.out.println("Ne moze da se obradi ponuda, jer je vec obradjena!!!"); return this;}
}

class Neobradjena extends Stanje
{@Override
 Stanje obradi() {System.out.println("Ponuda je obradjena!!!"); return new Obradjena();}}

class NullStanje extends Stanje
{ @Override
  Stanje obradi() {System.out.println("Ne moze da se obradi nepostojeca ponuda!!!"); return this;}
}

class Ponuda 
{String ponuda;
 
 Stanje stanjePonude;
 Ponuda(){stanjePonude = new Neobradjena();}
 void postaviStanjePonude(Stanje stanje1)
   {  if (stanje1!=null)
        stanjePonude=stanje1;
      else
       stanjePonude=new NullStanje();
   }
 void obradi(){stanjePonude = stanjePonude.obradi();}
}



class UpravaFakulteta   
{
  SILAB sil; 
  UpravaFakulteta(SILAB sil1){sil = sil1;}

  void Konstruisi() 
    { sil.kreirajProgramskiJezik();
      sil.kreirajSUBP();
      sil.kreirajPonudu();
    }
   
  public static void main(String args[])
	{  UpravaFakulteta uf;

	   JavaTimPonuda jat = new JavaTimPonuda();  
	   uf = new UpravaFakulteta(jat);
	   uf.Konstruisi();
           // Ne moze se obraditi ponuda koja je vec obradjena.
           jat.obradiPonudu();
           // Java tim prestaje da ima ponudu.
           jat.postaviStanjePonude(null);
           // Ne moze se obraditi ponuda koja ne postoji.
           jat.obradiPonudu();
}
}


abstract class  SILAB 
{  ProgramskiJezik  pj; 
    SUBP subp; 
    Ponuda pon;

   abstract void kreirajProgramskiJezik();
   abstract void kreirajSUBP();
   abstract void kreirajPonudu();
   abstract String vratiPonudu();
   abstract void obradiPonudu();
   abstract void postaviStanjePonude(Stanje s);
 }


class JavaTimPonuda extends SILAB 
{    
  JavaTimPonuda() {pon = new Ponuda();}
  @Override
  public void kreirajProgramskiJezik(){pj = new Java();}
  @Override
  public void kreirajSUBP() { subp = new MySQL();}
  @Override
  public void kreirajPonudu() { 
        pon.ponuda = "Programski jezik-" + pj.vratiProgramskiJezik() + " SUBP-" + subp.vratiSUBP();
        obradiPonudu();
        } 
  @Override
  public String vratiPonudu(){return pon.ponuda;}
  @Override
  public void obradiPonudu(){pon.obradi();}
  @Override
  void postaviStanjePonude(Stanje s){pon.postaviStanjePonude(s);}
}


interface ProgramskiJezik  {String vratiProgramskiJezik();}

class Java implements ProgramskiJezik {@Override
 public String vratiProgramskiJezik(){return "Java";}}

interface SUBP {String vratiSUBP();}

class MySQL implements SUBP {@Override
 public String vratiSUBP(){return "MySQL";}}


