/* PSTR2.UpravaFakulteta.java
 * @autor  prof. dr Sinisa Vlajic,
 * Univerzitet u Beogradu
 * Fakultet organizacionih nauka 
 * Katedra za softversko inzenjerstvo
 * Laboratorija za softversko inzenjerstvo
 * 05.12.2017
 */

package PSTR2;

/*   PSTR2:    (    )        , 
   3        . 
   500  ,         . 
    500  1000  ,           .
    1000  ,          .
*/

public class UpravaFakulteta   
{
  SILAB sil; 
  UpravaFakulteta(SILAB sil1) { sil = sil1;}

  public static void main(String args[])
     {   JavaTimPonuda jtp = new JavaTimPonuda();
         UpravaFakulteta uf = new UpravaFakulteta(jtp);
         uf.postaviBudzet(500);
         jtp.prikaziStrategiju();
         
     }
  void postaviBudzet(int budzet){sil.postaviBudzet(budzet);}
  void prikaziStrategiju(){sil.prikaziStrategiju();}
  
}

abstract class SILAB 
{ Strategija s;
  abstract void postaviBudzet(int budzet);
  abstract void prikaziStrategiju();
}
/*:    SILAB .*/
class JavaTimPonuda extends SILAB // Context
{ 
  @Override
  void postaviBudzet(int budzet)
    { if (budzet == 500) s = new Strategija1();
      if (budzet > 500 && budzet <= 1000) s = new Strategija2();
      if (budzet > 1000) s = new Strategija3();
    }
  @Override
  void prikaziStrategiju(){s.prikaziStrategiju();}
}

abstract class Strategija // Strategy
{abstract void prikaziStrategiju();}

class Strategija1 extends Strategija // ConcreteStrategyA
{ @Override
  void prikaziStrategiju() 
   {System.out.println("Napraviti softverski sistem!!!");
   }
}

class Strategija2 extends Strategija // ConcreteStrategyB
{ @Override
  void prikaziStrategiju() 
   {System.out.println("Napraviti softverski sistem!!!");
    System.out.println("Napisati programsku dokumentaciju!!!");
   }
}

class Strategija3 extends Strategija // ConcreteStrategyC
{ @Override
  void prikaziStrategiju() 
   {System.out.println("Napraviti softverski sistem!!!");
    System.out.println("Napisati kompletnu projektnu dokumentaciju!!!");
   }
}



